var mySetting = new aiSettings();
var ENTER_NAME_PERSON_TEXT="  ( - 32 ):";
var ENTER_BIRTHDAY_DATE_TEXT="  (..):";
var ENTER_BIRTHDAY_TIME_TEXT="     (:):";
var INC_TITLE_TEXT="";
var DEC_TITLE_TEXT="";
var BUTTON_ADD_PERSON_TEXT="";
var DEL_TITLE_TEXT="";

function loadSettings()
{
	mySetting.load();
	cntPersons.value=mySetting.cntPersons;
	System.Gadget.onSettingsClosing = settingsClosing;
	stNamePerson.innerHTML=ENTER_NAME_PERSON_TEXT;
	stBirthdayDate.innerHTML=ENTER_BIRTHDAY_DATE_TEXT;
	stBirthdayTime.innerHTML=ENTER_BIRTHDAY_TIME_TEXT;
	incDay.title=INC_TITLE_TEXT;
	decDay.title=DEC_TITLE_TEXT;
	incMonth.title=INC_TITLE_TEXT;
	decMonth.title=DEC_TITLE_TEXT;
	incYear.title=INC_TITLE_TEXT;
	decYear.title=DEC_TITLE_TEXT;
	incHour.title=INC_TITLE_TEXT;
	decHour.title=DEC_TITLE_TEXT;
	incMinute.title=INC_TITLE_TEXT;
	decMinute.title=DEC_TITLE_TEXT;
	buttonAddPerson.innerHTML=BUTTON_ADD_PERSON_TEXT;
	initFields();
	showListPersons();
}

function settingsClosing(event)
{
	if (event.closeAction == event.Action.commit)
	{
	saveSettings();
	}
}
function aiSettings()
{
	this.save = saveSettingToDisk;
	this.load = loadSettingFromDisk;
	this.cntPersons = 0;
	this.PersonsNames = new Array(0);
	this.PersonsBDays = new Array(0);
	this.PersonsBMonthes = new Array(0);
	this.PersonsBYears = new Array(0);
	this.PersonsBHours = new Array(0);
	this.PersonsBMinutes = new Array(0);
}
function loadSettingFromDisk()
{
	if (System.Gadget.Settings.read("SettingsExist"))
	{
		this.cntPersons=parseInt(System.Gadget.Settings.read("cntPersons"),10);
		this.PersonsNames=new Array(this.cntPersons);
		this.PersonsBDays=new Array(this.cntPersons);
		this.PersonsBMonthes=new Array(this.cntPersons);
		this.PersonsBYears=new Array(this.cntPersons);
		this.PersonsBHours=new Array(this.cntPersons);
		this.PersonsBMinutes=new Array(this.cntPersons);
		for(i=0;i<this.cntPersons;i++)
			{
			this.PersonsNames[i]=unescape(System.Gadget.Settings.readString("PersonsNames"+i));
			this.PersonsBDays[i]=parseInt(System.Gadget.Settings.read("PersonsBDays"+i));
			this.PersonsBMonthes[i]=parseInt(System.Gadget.Settings.read("PersonsBMonthes"+i));
			this.PersonsBYears[i]=parseInt(System.Gadget.Settings.read("PersonsBYears"+i));
			this.PersonsBHours[i]=parseInt(System.Gadget.Settings.read("PersonsBHours"+i));
			this.PersonsBMinutes[i]=parseInt(System.Gadget.Settings.read("PersonsBMinutes"+i));
			}
	}
}
function saveSettingToDisk()
{
	System.Gadget.Settings.write("SettingsExist", true);
	System.Gadget.Settings.write("cntPersons", this.cntPersons);
	for(i=0;i<this.cntPersons;i++)
		{
			System.Gadget.Settings.writeString("PersonsNames"+i, escape(this.PersonsNames[i]));
			System.Gadget.Settings.write("PersonsBDays"+i, this.PersonsBDays[i]);
			System.Gadget.Settings.write("PersonsBMonthes"+i, this.PersonsBMonthes[i]);
			System.Gadget.Settings.write("PersonsBYears"+i, this.PersonsBYears[i]);
			System.Gadget.Settings.write("PersonsBHours"+i, this.PersonsBHours[i]);
			System.Gadget.Settings.write("PersonsBMinutes"+i, this.PersonsBMinutes[i]);
		}
}
function saveSettings()
{
	mySetting.cntPersons=cntPersons.value;
	mySetting.save();
}

function addPerson()
{
	var fl=true;
	fl=fl && checkNamePerson();
	fl=fl && checkDate(dayBPerson,monthBPerson,yearBPerson);
	fl=fl && checkTime(timeHBPerson,timeMBPerson);
	if(fl)
		{
		mySetting.PersonsNames[mySetting.cntPersons]=namePerson.value;
		mySetting.PersonsBDays[mySetting.cntPersons]=dayBPerson.value;
		mySetting.PersonsBMonthes[mySetting.cntPersons]=monthBPerson.value;
		mySetting.PersonsBYears[mySetting.cntPersons]=yearBPerson.value;
		mySetting.PersonsBHours[mySetting.cntPersons]=timeHBPerson.value;
		mySetting.PersonsBMinutes[mySetting.cntPersons]=timeMBPerson.value;
		mySetting.cntPersons++;
		cntPersons.value=mySetting.cntPersons;
		showListPersons();
		}
}

function removePerson(ind)
{
	for(i=ind;i<(mySetting.cntPersons-1);i++)
		{
			mySetting.PersonsNames[i]=mySetting.PersonsNames[i+1];
			mySetting.PersonsBDays[i]=mySetting.PersonsBDays[i+1];
			mySetting.PersonsBMonthes[i]=mySetting.PersonsBMonthes[i+1];
			mySetting.PersonsBYears[i]=mySetting.PersonsBYears[i+1];
			mySetting.PersonsBHours[i]=mySetting.PersonsBHours[i+1];
			mySetting.PersonsBMinutes[i]=mySetting.PersonsBMinutes[i+1];
		}
	mySetting.cntPersons--;
	cntPersons.value=mySetting.cntPersons;
	showListPersons();
}

function changeDate(obj,k)
{
	if(obj!=null)
		if (!isNaN(parseInt(obj.value,10)))
			obj.value=parseInt(obj.value,10)+k;
}

function changeDate2(obj)
{
	if (event.keyCode == 38)
		{
		changeDate(obj,+1)
		}
	if (event.keyCode == 40)
		{
		changeDate(obj,-1)
		}
}

function trim(stringIn, removeFrom)
{ 
	var stringOut = "";
	stringIn = stringIn.toString();
	if (stringIn.length > 0)
	{
		switch (removeFrom) 
		{
			case "left":
				stringOut = stringIn.replace(/^\s+/g, ""); 
				break; 
			case "right": 
				stringOut = stringIn.replace(/\s+$/g, ""); 
				break; 
			case "both":
			default:
				stringOut = stringIn.replace(/^\s+|\s+$/g, "");
		}
	}
	return stringOut;
}

function checkNamePerson()
{
	if(trim(namePerson.value,"both")=="")
		{
		errMsg.innerHTML="   .";
		return false;
		}
	else
		{
		errMsg.innerHTML="";
		return true;
		}
}

function checkDate(ddo,mmo,yyo) {
	var dd,mm,yy,year;
	var fl=true;
	dd=parseInt(ddo.value,10);
	dd=isNaN(dd)?0:dd;
	mm=parseInt(mmo.value,10);
	mm=isNaN(mm)?0:mm;
	yy=parseInt(yyo.value,10);
	yy=isNaN(yy)?0:yy;
	if(dd<1) fl=false;
	if(mm<1) fl=false;
	if(mm>12) fl=false;
	if(yy<1900) fl=false;
	if(yy>2999) fl=false;
	if(fl)
		{
		var ar = new Array(31, ((yy%4==0&&yy%100!=0||yy%400==0) ? 29 : 28), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
		if(dd > ar[mm-1]) fl=false;
		}
	if(!fl)
		{
		errMsg.innerHTML="   .";
		return false;
		}
	else
		{
		errMsg.innerHTML="";
		return true;
		}
}

function checkTime(hho,mmo) {
	var hh,mm;
	var fl=true;
	hh=parseInt(hho.value,10);
	hh=isNaN(hh)?0:hh;
	mm=parseInt(mmo.value,10);
	mm=isNaN(mm)?0:mm;
	if(hh<0) fl=false;
	if(hh>23) fl=false;
	if(mm<0) fl=false;
	if(mm>59) fl=false;
	if(!fl)
		{
		errMsg.innerHTML="   .";
		return false;
		}
	else
		{
		errMsg.innerHTML="";
		return true;
		}
}

function initFields()
{
	var dt = new Date();
	dayBPerson.value = dt.getDate();
	monthBPerson.value = dt.getMonth()+1;
	yearBPerson.value = dt.getYear();
	timeHBPerson.value = 0;
	timeMBPerson.value = 0;
	namePerson.value= " ";
}

function showListPersons()
{
	s="";
	for(i=0;i<mySetting.cntPersons;i++)
	{
		s+=mySetting.PersonsNames[i]+" - "+mySetting.PersonsBDays[i]+"."+mySetting.PersonsBMonthes[i]+"."+mySetting.PersonsBYears[i]+" "+mySetting.PersonsBHours[i]+":"+mySetting.PersonsBMinutes[i]+" [<a title=\""+DEL_TITLE_TEXT+"\" href=\"javascript:void(0)\" onClick=\"removePerson("+i+")\">&#1059;</a>]";
		if(i!=(mySetting.cntPersons-1))
			s+="<br />";
	}
	listPersons.innerHTML=s;
}